/*
 *   Copyright 2007,2008 by Alex Merry <alex.merry@kdemail.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .
 */

#ifndef NOWPLAYING_H
#define NOWPLAYING_H

#include <plasma/applet.h>
#include <plasma/dataengine.h>

#include <QFont>

class NowPlaying : public Plasma::Applet
{
    Q_OBJECT

public:
    NowPlaying(QObject *parent, const QVariantList &args);
    ~NowPlaying();
    void init();
    void paintInterface(QPainter *p,
                        const QStyleOptionGraphicsItem *option,
                        const QRect &contentsRect);
    void constraintsUpdated(Plasma::Constraints);

public slots:
    void dataUpdated(const QString &name,
                     const Plasma::DataEngine::Data &data);
    void sizeChanged();

private:
    enum State {
        Playing,
        Paused,
        Stopped,
        NoPlayer
    };
    QString m_watchingPlayer;
    State m_state;
    QString m_artist;
    QString m_album;
    QString m_title;
    int m_track;
    QString m_comment;
    QString m_genre;
    int m_length;
    int m_position;
    QPixmap m_artwork;

    QFont m_font;
    bool m_fontDirty; // whether the font size needs recalculating
    QString m_leftColText;
};

K_EXPORT_PLASMA_APPLET(nowplaying, NowPlaying)

#endif // NOWPLAYING_H
